; representation of the gates
(deftemplate gate
             (slot number
                   (type INTEGER)
             )
             (slot gate_type
                   (type SYMBOL)
                   (allowed-symbols input output and or xor not line)
             )
             (multislot inputs
                        (type INTEGER)
             )
             (multislot outputs
                        (type INTEGER)
             )
)

(deftemplate gatePrioriProb
             (slot type
                   (type SYMBOL)
             )
             (slot state
                   (type SYMBOL)
             )
             (slot prob
                   (type FLOAT)
             )
)

(deftemplate gateBehaviour
             (slot gateType
                   (type SYMBOL)
             )
             (slot stateType
                   (type SYMBOL)
             )
             (slot valueP
                   (type INTEGER)
             )
             (slot valueQ
                   (type INTEGER)
                   (default -20)
             )
             (slot output
                   (type INTEGER)
             )
)

(deffacts aPrioriProbabilities
          (gatePrioriProb (type and)  (state correct)      (prob 0.98))
          (gatePrioriProb (type and)  (state kortsluiting) (prob 0.007))
          (gatePrioriProb (type and)  (state geenContact)  (prob 0.004))
          (gatePrioriProb (type and)  (state signaalP)     (prob 0.003))
          (gatePrioriProb (type and)  (state signaalQ)     (prob 0.003))
          (gatePrioriProb (type and)  (state inverted)     (prob 0.003))
          (gatePrioriProb (type or)   (state correct)      (prob 0.97))
          (gatePrioriProb (type or)   (state kortsluiting) (prob 0.007))
          (gatePrioriProb (type or)   (state geenContact)  (prob 0.005))
          (gatePrioriProb (type or)   (state signaalP)     (prob 0.006))
          (gatePrioriProb (type or)   (state signaalQ)     (prob 0.006))
          (gatePrioriProb (type or)   (state inverted)     (prob 0.006))
          (gatePrioriProb (type xor)  (state correct)      (prob 0.99))
          (gatePrioriProb (type xor)  (state kortsluiting) (prob 0.003))
          (gatePrioriProb (type xor)  (state geenContact)  (prob 0.004))
          (gatePrioriProb (type xor)  (state signaalP)     (prob 0.001))
          (gatePrioriProb (type xor)  (state signaalQ)     (prob 0.001))
          (gatePrioriProb (type xor)  (state inverted)     (prob 0.001))
          (gatePrioriProb (type not)  (state correct)      (prob 0.97))
          (gatePrioriProb (type not)  (state kortsluiting) (prob 0.008))
          (gatePrioriProb (type not)  (state geenContact)  (prob 0.008))
          (gatePrioriProb (type not)  (state inverted)     (prob 0.014))
          (gatePrioriProb (type line) (state correct)      (prob 0.99))
          (gatePrioriProb (type line) (state kortsluiting) (prob 0.003))
          (gatePrioriProb (type line) (state geenContact)  (prob 0.004))
          (gatePrioriProb (type line) (state inverted)     (prob 0.003))
)

(deffacts behaviourStats
          (gateBehaviour (gateType and) (stateType correct)      (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType correct)      (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType and) (stateType correct)      (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType and) (stateType correct)      (valueP 0) (valueQ 0) (output 0))
         
          (gateBehaviour (gateType and) (stateType kortsluiting) (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType kortsluiting) (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType and) (stateType kortsluiting) (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType kortsluiting) (valueP 0) (valueQ 0) (output 1))

          (gateBehaviour (gateType and) (stateType geenContact)  (valueP 1) (valueQ 1) (output 0))
          (gateBehaviour (gateType and) (stateType geenContact)  (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType and) (stateType geenContact)  (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType and) (stateType geenContact)  (valueP 0) (valueQ 0) (output 0))

          (gateBehaviour (gateType and) (stateType signaalP)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType signaalP)     (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType and) (stateType signaalP)     (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType and) (stateType signaalP)     (valueP 0) (valueQ 0) (output 0))
          
          (gateBehaviour (gateType and) (stateType signaalQ)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType signaalQ)     (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType and) (stateType signaalQ)     (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType signaalQ)     (valueP 0) (valueQ 0) (output 0))
          
          (gateBehaviour (gateType and) (stateType inverted)     (valueP 1) (valueQ 1) (output 0))
          (gateBehaviour (gateType and) (stateType inverted)     (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType and) (stateType inverted)     (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType and) (stateType inverted)     (valueP 0) (valueQ 0) (output 1))
          
          (gateBehaviour (gateType or) (stateType correct)      (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType correct)      (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType or) (stateType correct)      (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType correct)      (valueP 0) (valueQ 0) (output 0))
         
          (gateBehaviour (gateType or) (stateType kortsluiting) (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType kortsluiting) (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType or) (stateType kortsluiting) (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType kortsluiting) (valueP 0) (valueQ 0) (output 1))

          (gateBehaviour (gateType or) (stateType geenContact)  (valueP 1) (valueQ 1) (output 0))
          (gateBehaviour (gateType or) (stateType geenContact)  (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType or) (stateType geenContact)  (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType or) (stateType geenContact)  (valueP 0) (valueQ 0) (output 0))

          (gateBehaviour (gateType or) (stateType signaalP)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType signaalP)     (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType or) (stateType signaalP)     (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType or) (stateType signaalP)     (valueP 0) (valueQ 0) (output 0))
          
          (gateBehaviour (gateType or) (stateType signaalQ)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType signaalQ)     (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType or) (stateType signaalQ)     (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType or) (stateType signaalQ)     (valueP 0) (valueQ 0) (output 0))
          
          (gateBehaviour (gateType or) (stateType inverted)     (valueP 1) (valueQ 1) (output 0))
          (gateBehaviour (gateType or) (stateType inverted)     (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType or) (stateType inverted)     (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType or) (stateType inverted)     (valueP 0) (valueQ 0) (output 1))

          (gateBehaviour (gateType xor) (stateType correct)      (valueP 1) (valueQ 1) (output 0))
          (gateBehaviour (gateType xor) (stateType correct)      (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType xor) (stateType correct)      (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType correct)      (valueP 0) (valueQ 0) (output 0))

          (gateBehaviour (gateType xor) (stateType kortsluiting) (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType kortsluiting) (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType xor) (stateType kortsluiting) (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType kortsluiting) (valueP 0) (valueQ 0) (output 1))

          (gateBehaviour (gateType xor) (stateType geenContact)  (valueP 1) (valueQ 1) (output 0))
          (gateBehaviour (gateType xor) (stateType geenContact)  (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType xor) (stateType geenContact)  (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType xor) (stateType geenContact)  (valueP 0) (valueQ 0) (output 0))

          (gateBehaviour (gateType xor) (stateType signaalP)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType signaalP)     (valueP 1) (valueQ 0) (output 1))
          (gateBehaviour (gateType xor) (stateType signaalP)     (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType xor) (stateType signaalP)     (valueP 0) (valueQ 0) (output 0))
          
          (gateBehaviour (gateType xor) (stateType signaalQ)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType signaalQ)     (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType xor) (stateType signaalQ)     (valueP 0) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType signaalQ)     (valueP 0) (valueQ 0) (output 0))
          
          (gateBehaviour (gateType xor) (stateType inverted)     (valueP 1) (valueQ 1) (output 1))
          (gateBehaviour (gateType xor) (stateType inverted)     (valueP 1) (valueQ 0) (output 0))
          (gateBehaviour (gateType xor) (stateType inverted)     (valueP 0) (valueQ 1) (output 0))
          (gateBehaviour (gateType xor) (stateType inverted)     (valueP 0) (valueQ 0) (output 1))
          
          (gateBehaviour (gateType not) (stateType correct)      (valueP 1) (output 0))
          (gateBehaviour (gateType not) (stateType correct)      (valueP 0) (output 1))

          (gateBehaviour (gateType not) (stateType kortsluiting) (valueP 1) (output 1))
          (gateBehaviour (gateType not) (stateType kortsluiting) (valueP 0) (output 1))
          
          (gateBehaviour (gateType not) (stateType geenContact)  (valueP 1) (output 0))
          (gateBehaviour (gateType not) (stateType geenContact)  (valueP 0) (output 0))

          (gateBehaviour (gateType not) (stateType inverted)     (valueP 1) (output 1))
          (gateBehaviour (gateType not) (stateType inverted)     (valueP 0) (output 0))
          
          (gateBehaviour (gateType line) (stateType correct)      (valueP 1) (output 1))
          (gateBehaviour (gateType line) (stateType correct)      (valueP 0) (output 0))

          (gateBehaviour (gateType line) (stateType kortsluiting) (valueP 1) (output 1))
          (gateBehaviour (gateType line) (stateType kortsluiting) (valueP 0) (output 1))
          
          (gateBehaviour (gateType line) (stateType geenContact)  (valueP 1) (output 0))
          (gateBehaviour (gateType line) (stateType geenContact)  (valueP 0) (output 0))
          
          (gateBehaviour (gateType line) (stateType inverted)     (valueP 1) (output 0))
          (gateBehaviour (gateType line) (stateType inverted)     (valueP 0) (output 1))
)
          

